
//
//	HSP3 COM support
//	onion software/onitama 2005/4
//

#include "../hsp3/hsp3config.h"

#ifdef HSPWIN
#define USE_WINDOWS_COM		// WindowsCOM APIgp
#endif

#ifdef USE_WINDOWS_COM
#include <windows.h>
#include <ocidl.h>
#include <objbase.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "comutil.h"

#ifdef USE_WINDOWS_COM
/*------------------------------------------------------------*/
/*
		Windows̏ꍇ͈ȉgpĂB
*/
/*------------------------------------------------------------*/

static void cnvwstr( void *out, char *in, int bufsize )
{
	//	sjis->unicode ɕϊ
	//
	MultiByteToWideChar( CP_ACP, 0, in, -1, (LPWSTR)out, bufsize );
}

static int GetIIDFromString( IID *iid, char *ps, bool fClsid = false )
{
	//		SJIS IID  IID \̂𓾂
	//
	//		fClsid ^̂ƂAProgID  CLSID 擾݂
	//		ProgID ̕ϊɎsꍇ 1 Ԃ
	//		(ȊÕG[͗O throw)
	//
	char stmp[1024];
	HRESULT hr;
	cnvwstr( stmp, ps, 1024 );
	if ( *ps == '{' ) {
		// GUID   GUID \
		hr = IIDFromString( (LPOLESTR)stmp, iid );
		if ( SUCCEEDED(hr) ) return 0;
	}
	if ( fClsid ) {
		// ProgID   GUID \
		hr = CLSIDFromProgID( (LPOLESTR)stmp, iid );
		if ( SUCCEEDED(hr) ) return 0;
		return 1;
	}
	return -1;
}

int ConvertIID( COM_GUID *guid, char *name )
{
	return GetIIDFromString( (IID *)guid, name );
}

#else

/*------------------------------------------------------------*/
/*
		interface
*/
/*------------------------------------------------------------*/

int ConvertIID( COM_GUID *guid, char *name )
{
	//		SJIS IID  IID \̂𓾂
	//		(COMT|[gꍇ͕ϊKv)
	return 0;
}

#endif
